<?php
/* **************************************************************************** *

 * cor-mysql-interface.php							*
 * @package	Core								*
 * @copyright:	Copyright (c) 2008 Martin Novák. All rights reserved		*
 * @license	GNU/AGPL http://www.gnu.org/licenses/agpl.html			*
 
 * Albireo is free software! You can redistribute it and/or modify it under	*
 * the terms of the GNU Affero General Public License as published		*
 * by the Free Software Foundation, either version 3 of the License, or		*
 * (at your option) any later version.						*

 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the		*
 *	GNU Affero General Public License for more details.			*

 This script description:
 Page with interface for cuminicating with MySQL database.

 Properties:
    array $page			// contains changes for array $page in ScriptPage
 	
 Public Methods:
    none
 	
 * **************************************************************************** */

class MySQLInterface {

    public $page = array ( "text" => "" );
    private $total_affected_rows = 0;
    private $total_query_time = 0.0;

    public function __construct ()
    {

    	if ( !isset ( $_POST [ "query" ] ) ) {
            $this -> page [ "text" ] .= _( "<p>Databázové rozhraní vám umožňuje přímo zadávat SQL příkazy v plném rozsahu, ke kterému máte
                uživatelská práva.</p>" ).
    	    "<form action=\"". Tools::getPage () ."\" method=\"post\" enctype=\"application/x-www-form-urlencoded\" class=\"formular\">
    	    	  <fieldset>
                    <strong>"._("Zadejte prosím SQL dotazy, které mají být provedeny:")."</strong><br />
                    <textarea name=\"query\" cols=\"50\" rows=\"10\"></textarea><br />
                    <input class=\"dialoguebutton\" type=\"submit\" value=\"Provést příkaz\" />
                  </fieldset>
            </form>
            <script type=\"text/javascript\">dialogueButtons();</script>";
    	} else {
            $this -> page [ "text" ] .= '<input type="button" class="dialoguebutton" value="'._("Nový SQL dotaz").'" onclick="window.location=\''.Tools::getFullPage().'\';" />';
            $begin = microtime ( true );
            $this -> process_queries ();
            $this -> page [ "text" ] .= '<input type="button" class="dialoguebutton" value="'. _( "Nový SQL dotaz" ) .'" onclick="window.location=\''.Tools::getFullPage().'\';" />
                                         <script type="text/javascript">dialogueButtons();$("p").css("text-align","left");</script>
                                         <p>'. _( "Celkem ovlivněno " ) ." ". $this -> total_affected_rows ." ". ( "řádků za" ) ." ". $this -> total_query_time ." ". _( "sekund." ) .'<br />
                                         '. _( "Albireo akci zpracovalo i s výstupem za" ) .' '. ( microtime ( true ) - $begin ) .' '. _( "sekund." ) .'</p>';
    	}
    } // end __construct

    private function process_queries ()
    {

        $dbhost = Tools::baseSettings () -> getSetting ( "dbhost" );
    	$user = Tools::baseSettings () -> getSetting ( "user" );
    	$pass = Tools::baseSettings () -> getSetting ( "pass" );
    	$dbname = Tools::baseSettings () -> getSetting ( "dbname" );

        $mysqli = new Mysqli ( $dbhost, $user, $pass, $dbname );
        if ( mysqli_connect_errno () ) {
            $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Přihlášení k MySQL databázi selhalo:" ) .' '. mysqli_connect_errno () .': '. mysqli_connect_error () .'</strong></p>';
        }

        $mysqli -> query ( "SET NAMES 'utf8' COLLATE 'utf8_general_ci';" );

        $query_string = stripslashes ( $_POST [ "query" ] );
        $queries = explode ( "\n", $query_string );
        $delimiter = ";";
        $delimiter_length = 1;
        $sql = "";
        @set_time_limit ( 0 );
        foreach ( $queries as $query ) {
            $line = $query."\n";
            if ( substr ( ltrim ( $line ), 0, 2 ) !== '--' ) {
                $sql .= $line;
                if ( strtolower ( substr ( ltrim ( $line ), 0, 9 ) ) !== 'delimiter' ) {
                    if ( substr ( rtrim ( $line ), -$delimiter_length ) === $delimiter ) {
                        if ( $delimiter != ";" ) $sql = substr ( rtrim ( $sql ), 0, -$delimiter_length );
                        $this -> runImprovedQuery ( $sql, $mysqli );
                        $sql = "";
                    }
                } else {
                    $delimiter = substr ( trim ( $line ), 10 );
                    $delimiter_length = strlen ( $delimiter );
                    $sql = "";
                }
            }
        }
        if ( trim ( $sql ) != "" ) {
            $this -> runImprovedQuery ( $sql, $mysqli );
        }
        
    } // end process_queries

    private function runImprovedQuery ( $query, $mysqli )
    {
        $this -> page [ "text" ] .= "<p>". _( "Výsledek dotazu" ). ": <strong>".nl2br ( htmlspecialchars ( $query ) ) .'</strong></p>';
        $begin = microtime ( true );
        if ( $mysqli -> multi_query ( $query ) !== false ) {
            $end = microtime ( true );
            $query_time = $end - $begin;
            $affected_rows = 0;
            $this -> total_query_time += $query_time;
            do {
                $result = $mysqli -> store_result ();
                if ( $result !== false ) {
                    $this -> page [ "text" ] .= '<table class="table"><thead><tr>';
                    while ( $finfo = $result -> fetch_field () ) {
                        $this -> page [ "text" ] .= '<th>'. $finfo -> name .'</th>';
                    }
                    $this -> page [ "text" ] .= '</tr></thead><tbody>';
                    while ( $rows = $result -> fetch_row () ) {
                        $this -> page [ "text" ] .= "<tr>";
                        foreach ( $rows as $row ) {
                            $this -> page [ "text" ] .= "<td>". nl2br ( htmlspecialchars ( $row ) ) ."</td>";
                        }
                        $this -> page [ "text" ] .= "</tr>";
                    }
                    $this -> page [ "text" ] .= '</tbody></table>';
                    $result -> free();
                } elseif ( $mysqli -> errno == 0 ) {
                    $result = $mysqli -> query ( "SELECT ROW_COUNT()" );
                    if ( $result !== false ) {
                        $array = $result -> fetch_row ();
                        if ( !is_array ( $array ) ) {
                            $affected_rows = current ( $array );
                            if ( $affected_rows < 0 ) $affected_rows = 0;
                            $this -> total_affected_rows += $affected_rows;
                        }
                        $result -> free();
                    }
                    $this -> page [ "text" ] .= '<p><strong class="success">'. _( "MySQL dotaz proběhl úspěšně." ) .'</strong></p>';
                } else {
                    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "MySQL dotaz selhal:" ) .' '. $mysqli -> errno .': '. $mysqli -> error .'</strong></p>';
                }
                $this -> page [ "text" ] .= "<p>"._( "Ovlivněno " )." ".$affected_rows." ".("řádků za")." ".$query_time." ". _( "sekund." ) ."</p>";
            } while ( $mysqli -> next_result () );
        } else {
            $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Provádění MySQL dotazu selhalo:" ) .' '. $mysqli -> errno .': '. $mysqli -> error .'</strong></p>';
        }
    }

}

$MySQLInterface = new MySQLInterface ();
$page = $MySQLInterface -> page;
?>